// Auto-generated. Do not edit!

// (in-package tf2_server.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------


//-----------------------------------------------------------

class RequestTransformStreamRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.parent_frame = null;
      this.child_frames = null;
      this.intermediate_frames = null;
      this.publication_period = null;
      this.allow_transforms_update = null;
      this.publisher_queue_size = null;
      this.requested_topic_name = null;
      this.requested_static_topic_name = null;
    }
    else {
      if (initObj.hasOwnProperty('parent_frame')) {
        this.parent_frame = initObj.parent_frame
      }
      else {
        this.parent_frame = '';
      }
      if (initObj.hasOwnProperty('child_frames')) {
        this.child_frames = initObj.child_frames
      }
      else {
        this.child_frames = [];
      }
      if (initObj.hasOwnProperty('intermediate_frames')) {
        this.intermediate_frames = initObj.intermediate_frames
      }
      else {
        this.intermediate_frames = false;
      }
      if (initObj.hasOwnProperty('publication_period')) {
        this.publication_period = initObj.publication_period
      }
      else {
        this.publication_period = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('allow_transforms_update')) {
        this.allow_transforms_update = initObj.allow_transforms_update
      }
      else {
        this.allow_transforms_update = false;
      }
      if (initObj.hasOwnProperty('publisher_queue_size')) {
        this.publisher_queue_size = initObj.publisher_queue_size
      }
      else {
        this.publisher_queue_size = 0;
      }
      if (initObj.hasOwnProperty('requested_topic_name')) {
        this.requested_topic_name = initObj.requested_topic_name
      }
      else {
        this.requested_topic_name = '';
      }
      if (initObj.hasOwnProperty('requested_static_topic_name')) {
        this.requested_static_topic_name = initObj.requested_static_topic_name
      }
      else {
        this.requested_static_topic_name = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RequestTransformStreamRequest
    // Serialize message field [parent_frame]
    bufferOffset = _serializer.string(obj.parent_frame, buffer, bufferOffset);
    // Serialize message field [child_frames]
    bufferOffset = _arraySerializer.string(obj.child_frames, buffer, bufferOffset, null);
    // Serialize message field [intermediate_frames]
    bufferOffset = _serializer.bool(obj.intermediate_frames, buffer, bufferOffset);
    // Serialize message field [publication_period]
    bufferOffset = _serializer.duration(obj.publication_period, buffer, bufferOffset);
    // Serialize message field [allow_transforms_update]
    bufferOffset = _serializer.bool(obj.allow_transforms_update, buffer, bufferOffset);
    // Serialize message field [publisher_queue_size]
    bufferOffset = _serializer.int32(obj.publisher_queue_size, buffer, bufferOffset);
    // Serialize message field [requested_topic_name]
    bufferOffset = _serializer.string(obj.requested_topic_name, buffer, bufferOffset);
    // Serialize message field [requested_static_topic_name]
    bufferOffset = _serializer.string(obj.requested_static_topic_name, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RequestTransformStreamRequest
    let len;
    let data = new RequestTransformStreamRequest(null);
    // Deserialize message field [parent_frame]
    data.parent_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [child_frames]
    data.child_frames = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [intermediate_frames]
    data.intermediate_frames = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [publication_period]
    data.publication_period = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [allow_transforms_update]
    data.allow_transforms_update = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [publisher_queue_size]
    data.publisher_queue_size = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [requested_topic_name]
    data.requested_topic_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [requested_static_topic_name]
    data.requested_static_topic_name = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.parent_frame.length;
    object.child_frames.forEach((val) => {
      length += 4 + val.length;
    });
    length += object.requested_topic_name.length;
    length += object.requested_static_topic_name.length;
    return length + 30;
  }

  static datatype() {
    // Returns string type for a service object
    return 'tf2_server/RequestTransformStreamRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a7c59a6e27bac6bb75c581e511c7bdba';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string parent_frame  # the top-most frame in TF tree you're interested in
    string[] child_frames  # if empty, stream the whole subtree of parent_frame
    bool intermediate_frames  # if false, stream only direct parent->child TFs (no matter if they were originally direct neighbors); if true, stream all the TFs between parent and all children
    duration publication_period  # how often to publish the TFs
    bool allow_transforms_update  # if true, not all transforms have to be available at the time of call - they will be searched for continuously
    int32 publisher_queue_size  # queue size of the publisher
    string requested_topic_name  # if nonempty, request this topic name for TFs
    string requested_static_topic_name  # if nonempty, request this topic name for static TFs
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RequestTransformStreamRequest(null);
    if (msg.parent_frame !== undefined) {
      resolved.parent_frame = msg.parent_frame;
    }
    else {
      resolved.parent_frame = ''
    }

    if (msg.child_frames !== undefined) {
      resolved.child_frames = msg.child_frames;
    }
    else {
      resolved.child_frames = []
    }

    if (msg.intermediate_frames !== undefined) {
      resolved.intermediate_frames = msg.intermediate_frames;
    }
    else {
      resolved.intermediate_frames = false
    }

    if (msg.publication_period !== undefined) {
      resolved.publication_period = msg.publication_period;
    }
    else {
      resolved.publication_period = {secs: 0, nsecs: 0}
    }

    if (msg.allow_transforms_update !== undefined) {
      resolved.allow_transforms_update = msg.allow_transforms_update;
    }
    else {
      resolved.allow_transforms_update = false
    }

    if (msg.publisher_queue_size !== undefined) {
      resolved.publisher_queue_size = msg.publisher_queue_size;
    }
    else {
      resolved.publisher_queue_size = 0
    }

    if (msg.requested_topic_name !== undefined) {
      resolved.requested_topic_name = msg.requested_topic_name;
    }
    else {
      resolved.requested_topic_name = ''
    }

    if (msg.requested_static_topic_name !== undefined) {
      resolved.requested_static_topic_name = msg.requested_static_topic_name;
    }
    else {
      resolved.requested_static_topic_name = ''
    }

    return resolved;
    }
};

class RequestTransformStreamResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.topic_name = null;
      this.static_topic_name = null;
    }
    else {
      if (initObj.hasOwnProperty('topic_name')) {
        this.topic_name = initObj.topic_name
      }
      else {
        this.topic_name = '';
      }
      if (initObj.hasOwnProperty('static_topic_name')) {
        this.static_topic_name = initObj.static_topic_name
      }
      else {
        this.static_topic_name = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RequestTransformStreamResponse
    // Serialize message field [topic_name]
    bufferOffset = _serializer.string(obj.topic_name, buffer, bufferOffset);
    // Serialize message field [static_topic_name]
    bufferOffset = _serializer.string(obj.static_topic_name, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RequestTransformStreamResponse
    let len;
    let data = new RequestTransformStreamResponse(null);
    // Deserialize message field [topic_name]
    data.topic_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [static_topic_name]
    data.static_topic_name = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.topic_name.length;
    length += object.static_topic_name.length;
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'tf2_server/RequestTransformStreamResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '42ea15d06263d0e97103be7c351c819e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string topic_name  # absolute name of the topic where the transform stream gets published
    string static_topic_name  # absolute name of the topic where static transforms get published
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RequestTransformStreamResponse(null);
    if (msg.topic_name !== undefined) {
      resolved.topic_name = msg.topic_name;
    }
    else {
      resolved.topic_name = ''
    }

    if (msg.static_topic_name !== undefined) {
      resolved.static_topic_name = msg.static_topic_name;
    }
    else {
      resolved.static_topic_name = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: RequestTransformStreamRequest,
  Response: RequestTransformStreamResponse,
  md5sum() { return 'a05cc2e9041acc92c6caa8540a3ba53b'; },
  datatype() { return 'tf2_server/RequestTransformStream'; }
};
